/*	Renegade Scripts.dll
	Copyright 2011 Tiberian Technologies

	This file is part of the Renegade scripts.dll
	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
	the terms of the GNU General Public License as published by the Free
	Software Foundation; either version 2, or (at your option) any later
	version. See the file COPYING for more details.
	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
	Only the source code to the module(s) containing the licenced code has to be released.
*/
#include "general.h"

#include "scripts.h"
#include "slist.h"
#include "GameObjManager.h"
#include "engine_tt.h"
#include "engine_game.h"
#include "engine_obj.h"
#include "engine_def.h"
#include "engine_player.h"
#include "engine_obj2.h"
#include "engine_script.h"
#include "SmartGameObjDef.h"
#include "VehicleGameObj.h"
#include "SoldierGameObj.h"
#include "VehicleFactoryGameObj.h"
#include "VehicleFactoryGameObjDef.h"
#include "AirFactoryGameObj.h"
class WideStringClass;


SCRIPTS_API gpl Get_Player_List;
SCRIPTS_API gcmi Get_Current_Map_Index;
SCRIPTS_API gm Get_Map;
SCRIPTS_API smx Set_Map;
SCRIPTS_API ggd Get_Game_Definitions;
SCRIPTS_API _Enable_Stealth_Player Enable_Stealth_Player;
SCRIPTS_API _Set_Fog_Enable_Player Set_Fog_Enable_Player;
SCRIPTS_API _Set_Fog_Range_Player Set_Fog_Range_Player;
SCRIPTS_API _Set_Background_Music_Player Set_Background_Music_Player;
SCRIPTS_API _Fade_Background_Music_Player Fade_Background_Music_Player;
SCRIPTS_API _Stop_Background_Music_Player Stop_Background_Music_Player;
SCRIPTS_API _Enable_Radar_Player Enable_Radar_Player;
SCRIPTS_API _Display_GDI_Player_Terminal_Player Display_GDI_Player_Terminal_Player;
SCRIPTS_API _Display_NOD_Player_Terminal_Player Display_NOD_Player_Terminal_Player;
SCRIPTS_API _Set_Screen_Fade_Color_Player Set_Screen_Fade_Color_Player;
SCRIPTS_API _Set_Screen_Fade_Opacity_Player Set_Screen_Fade_Opacity_Player;
SCRIPTS_API _Force_Camera_Look_Player Force_Camera_Look_Player;
SCRIPTS_API _Enable_HUD_Player Enable_HUD_Player;
SCRIPTS_API _Create_Sound_Player Create_Sound_Player;
SCRIPTS_API _Create_2D_Sound_Player Create_2D_Sound_Player;
SCRIPTS_API _Create_2D_WAV_Sound_Player Create_2D_WAV_Sound_Player;
SCRIPTS_API _Create_3D_WAV_Sound_At_Bone_Player Create_3D_WAV_Sound_At_Bone_Player;
SCRIPTS_API _Create_3D_Sound_At_Bone_Player Create_3D_Sound_At_Bone_Player;
SCRIPTS_API _Set_Obj_Radar_Blip_Shape_Player Set_Obj_Radar_Blip_Shape_Player;
SCRIPTS_API _Set_Obj_Radar_Blip_Color_Player Set_Obj_Radar_Blip_Color_Player;
SCRIPTS_API aoch AddObjectCreateHook;
SCRIPTS_API roch RemoveObjectCreateHook;
SCRIPTS_API asn AddShaderNotify;
SCRIPTS_API rsn RemoveShaderNotify;
SCRIPTS_API akh AddKeyHook;
SCRIPTS_API rkh RemoveKeyHook;
SCRIPTS_API ach AddChatHook;
SCRIPTS_API ahh AddHostHook;
SCRIPTS_API arh AddRefillHook;
SCRIPTS_API allh AddLoadLevelHook;
SCRIPTS_API allh AddGameOverHook;
SCRIPTS_API allh AddThinkHook;
SCRIPTS_API apjh AddPlayerJoinHook;
SCRIPTS_API arch AddRadioHook;
SCRIPTS_API aplh AddPlayerLeaveHook;
SCRIPTS_API aph AddPowerupPurchaseHook;
SCRIPTS_API aph AddVehiclePurchaseHook;
SCRIPTS_API aph AddCharacterPurchaseHook;
SCRIPTS_API apmh AddPowerupPurchaseMonHook;
SCRIPTS_API apmh AddVehiclePurchaseMonHook;
SCRIPTS_API apmh AddCharacterPurchaseMonHook;
SCRIPTS_API rph RemovePowerupPurchaseHook;
SCRIPTS_API rph RemoveVehiclePurchaseHook;
SCRIPTS_API rph RemoveCharacterPurchaseHook;
SCRIPTS_API rph RemovePowerupPurchaseMonHook;
SCRIPTS_API rph RemoveVehiclePurchaseMonHook;
SCRIPTS_API rph RemoveCharacterPurchaseMonHook;
SCRIPTS_API gcmt GetCurrentMusicTrack;
SCRIPTS_API sit Set_Info_Texture;
SCRIPTS_API cit Clear_Info_Texture;
SCRIPTS_API svl Set_Vehicle_Limit;
SCRIPTS_API gvl Get_Vehicle_Limit;
SCRIPTS_API svl Set_Air_Vehicle_Limit;
SCRIPTS_API gvl Get_Air_Vehicle_Limit;
SCRIPTS_API sm Send_Message;
SCRIPTS_API smp Send_Message_Player;
SCRIPTS_API sw Set_Wireframe_Mode;
SCRIPTS_API lnhi Load_New_HUD_INI;
SCRIPTS_API rw Remove_Weapon;
SCRIPTS_API crm Change_Radar_Map;
SCRIPTS_API gbm Get_Build_Time_Multiplier;
SCRIPTS_API scb Set_Currently_Building;
SCRIPTS_API icb Is_Currently_Building;
SCRIPTS_API acoh AddConsoleOutputHook;
SCRIPTS_API acoh AddLogFileHook;
SCRIPTS_API sfc Set_Fog_Color;
SCRIPTS_API sfcp Set_Fog_Color_Player;
SCRIPTS_API sfm Set_Fog_Mode;
SCRIPTS_API sfmp Set_Fog_Mode_Player;
SCRIPTS_API shn Send_HUD_Number;
SCRIPTS_API sfd Set_Fog_Density;
SCRIPTS_API sfdp Set_Fog_Density_Player;
SCRIPTS_API ctr Change_Time_Remaining;
SCRIPTS_API ctl Change_Time_Limit;
SCRIPTS_API dps Display_Security_Dialog;
SCRIPTS_API geo GetExplosionObj;
SCRIPTS_API seo SetExplosionObj;
SCRIPTS_API dod Do_Objectives_Dlg;
SCRIPTS_API sl Set_Player_Limit;
SCRIPTS_API gl Get_Player_Limit;
SCRIPTS_API _Get_Fog_Range Get_Fog_Range;
SCRIPTS_API sspp Send_Shader_Param_Player;
SCRIPTS_API ssp Send_Shader_Param;
SCRIPTS_API sspop Send_Shader_Param_Obj_Player;
SCRIPTS_API sspo Send_Shader_Param_Obj;
SCRIPTS_API ssn Set_GDI_Soldier_Name;
SCRIPTS_API ssn Set_Nod_Soldier_Name;
SCRIPTS_API Get_IP_Addressx Get_IP_Address;
SCRIPTS_API Get_IP_Portx Get_IP_Port;
SCRIPTS_API Get_IPx Get_IP;
SCRIPTS_API Get_Bandwidthx Get_Bandwidth;
SCRIPTS_API Get_Pingx Get_Ping;
SCRIPTS_API Get_Kbitsx Get_Kbits;
SCRIPTS_API sfop Set_Fog_Override_Player;
SCRIPTS_API cfop Clear_Fog_Override_Player;
SCRIPTS_API dgh Display_Game_Hint;
SCRIPTS_API dghi Display_Game_Hint_Image;
SCRIPTS_API sclb Set_Current_Bullets;
SCRIPTS_API sclb Set_Current_Clip_Bullets;
SCRIPTS_API spb Set_Position_Bullets;
SCRIPTS_API spb Set_Position_Clip_Bullets;
SCRIPTS_API sb Set_Bullets;
SCRIPTS_API sb Set_Clip_Bullets;
SCRIPTS_API smie Set_Moon_Is_Earth;
SCRIPTS_API gml Get_Mine_Limit;
SCRIPTS_API sbd Set_Special_Base_Destruction;
SCRIPTS_API gpv Get_Client_Version;
SCRIPTS_API gdw Get_Damage_Warhead;
SCRIPTS_API ggobpn Get_GameObj_By_Player_Name;
SCRIPTS_API scap Send_Custom_All_Players;
SCRIPTS_API stc Steal_Team_Credits;
SCRIPTS_API gtc Get_Team_Credits;
SCRIPTS_API ssn Set_Objects_Filename;
SCRIPTS_API addConnectionAcceptanceFilterType addConnectionAcceptanceFilter;
SCRIPTS_API removeConnectionAcceptanceFilterType removeConnectionAcceptanceFilter;
SCRIPTS_API ec Evict_Client;
SCRIPTS_API gcsh Get_Client_Serial_Hash;

SCRIPTS_API bool Can_Team_Build_Vehicle(int Team)
{
	if (Is_Currently_Building(Team))
	{
		return false;
	}
	GameObject *factory = Find_Vehicle_Factory(Team);
	if (factory)
	{
		return Is_Available_For_Purchase(factory);
	}
	return true;
}

SCRIPTS_API void Send_Message_With_Team_Color(int Team,const char *Msg)
{
	unsigned int Red = 0,Blue = 0,Green = 0;
	Get_Team_Color(Team,&Red,&Green,&Blue);
	Send_Message(Red,Green,Blue,Msg);
}

SCRIPTS_API void Send_Message_With_Obj_Color(GameObject *obj,const char *Msg)
{
	unsigned int Red = 0,Blue = 0,Green = 0;
	Get_Object_Color(obj,&Red,&Green,&Blue);
	Send_Message(Red,Green,Blue,Msg);
}

SCRIPTS_API void Send_Message_Team(int team,unsigned int red,unsigned int green,unsigned int blue,const char *msg)
{
	SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
	while (x)
	{
		GameObject *o = As_SmartGameObj(x->Data());
		if (o)
		{
			if ((Get_Object_Type(o) == team) || (team == 2))
			{
				Send_Message_Player(o,red,green,blue,msg);
			}
		}
		x = x->Next();
	}
}

SCRIPTS_API void Set_Obj_Radar_Blip_Shape_Team(int Team,GameObject *obj,int shape)
{
	SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
	while (x)
	{
		GameObject *o = As_SmartGameObj(x->Data());
		if (o)
		{
			if ((Get_Object_Type(o) == Team) || (Team == 2))
			{
				Set_Obj_Radar_Blip_Shape_Player(o,obj,shape);
			}
		}
		x = x->Next();
	}
}

SCRIPTS_API void Set_Obj_Radar_Blip_Color_Team(int Team,GameObject *obj,int color)
{
	SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
	while (x)
	{
		GameObject *o = As_SmartGameObj(x->Data());
		if (o)
		{
			if ((Get_Object_Type(o) == Team) || (Team == 2))
			{
				Set_Obj_Radar_Blip_Color_Player(o,obj,color);
			}
		}
		x = x->Next();
	}
}

SCRIPTS_API void Set_Occupants_Fade(GameObject *obj,float red,float green,float blue,float opacity)
{
	if (!obj || !Commands->Get_ID(obj))
	{
		return;
	}
	if (!As_VehicleGameObj(obj))
	{
		return;
	}
	VehicleGameObj *o = (VehicleGameObj *)obj;
	int x = o->Get_Definition().Get_Seat_Count();
	for (int i = 0;i < x;i++)
	{
		if (o->Get_Occupant(i))
		{
			Set_Screen_Fade_Color_Player(o->Get_Occupant(i),red,green,blue,0);
			Set_Screen_Fade_Opacity_Player(o->Get_Occupant(i),opacity,0);
		}
	}
}

SCRIPTS_API void Enable_Team_Radar(int Team,bool Enable)
{
	SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
	while (x)
	{
		GameObject *o = As_SmartGameObj(x->Data());
		if (o)
		{
			if ((Get_Object_Type(o) == Team) || (Team == 2))
			{
				Enable_Radar_Player(o,Enable);
			}
		}
		x = x->Next();
	}
}

SCRIPTS_API void Create_Sound_Team(const char *soundname,const Vector3 & position,GameObject *obj,int team)
{
	if (!obj || !Commands->Get_ID(obj))
	{
		return;
	}
	SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
	while (x)
	{
		GameObject *o = As_SmartGameObj(x->Data());
		if (o)
		{
			if ((Get_Object_Type(o) == team) || (team == 2))
			{
				Create_Sound_Player(o,soundname,position,obj);
			}
		}
		x = x->Next();
	}
}

SCRIPTS_API void Create_2D_Sound_Team(const char *soundname,int team)
{
	SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
	while (x)
	{
		GameObject *o = As_SmartGameObj(x->Data());
		if (o)
		{
			if ((Get_Object_Type(o) == team) || (team == 2))
			{
				Create_2D_Sound_Player(o,soundname);
			}
		}
		x = x->Next();
	}
}

SCRIPTS_API void Create_2D_WAV_Sound_Team(const char *soundname,int team)
{
	SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
	while (x)
	{
		GameObject *o = As_SmartGameObj(x->Data());
		if (o)
		{
			if ((Get_Object_Type(o) == team) || (team == 2))
			{
				Create_2D_WAV_Sound_Player(o,soundname);
			}
		}
		x = x->Next();
	}
}

SCRIPTS_API void Create_3D_WAV_Sound_At_Bone_Team(const char *soundname,GameObject *obj,const char *bonename,int team)
{
	if (!obj || !Commands->Get_ID(obj))
	{
		return;
	}
	SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
	while (x)
	{
		GameObject *o = As_SmartGameObj(x->Data());
		if (o)
		{
			if ((Get_Object_Type(o) == team) || (team == 2))
			{
				Create_3D_WAV_Sound_At_Bone_Player(o,soundname,obj,bonename);
			}
		}
		x = x->Next();
	}
}

SCRIPTS_API void Create_3D_Sound_At_Bone_Team(const char *soundname,GameObject *obj,const char *bonename,int team)
{
	if (!obj || !Commands->Get_ID(obj))
	{
		return;
	}
	SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
	while (x)
	{
		GameObject *o = As_SmartGameObj(x->Data());
		if (o)
		{
			if ((Get_Object_Type(o) == team) || (team == 2))
			{
				Create_3D_Sound_At_Bone_Player(o,soundname,obj,bonename);
			}
		}
		x = x->Next();
	}
}

SCRIPTS_API void Ranged_Stealth_On_Team(Gap_ListNode* FirstNode)
{
	SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
	if (FirstNode)
	{
		while (x)
		{
			GameObject *o = x->Data();
			if (o)
			{
				bool tested = false;
				Gap_ListNode *current = FirstNode;
				int test = Commands->Get_Player_Type(o);
				if (o->As_VehicleGameObj() && o->As_VehicleGameObj()->Get_Lock_Team() != 2)
				{
					test = o->As_VehicleGameObj()->Get_Lock_Team();
				}
				SmartGameObjDef *d = (SmartGameObjDef *)Get_Definition(o);
				if (!d->Is_Stealthed())
				{
					if (Is_Vehicle(o) || Is_Soldier(o))
					{
						while (!tested)
						{
							if (current)
							{
								if (current->active)
								{
									Vector3 GenPos = Commands->Get_Position(Commands->Find_Object(current->unitID));
									Vector3 TargetPos = Commands->Get_Position(o);
									float distance = Commands->Get_Distance(GenPos, TargetPos);
									if (distance <= current->range)
									{
										if (test == current->teamID)
										{
											Commands->Enable_Stealth(o, true);
											current = NULL;
											tested = true;
										}
										else
										{
											current = current->Next;
										}
									}
									else
									{
										current = current->Next;
									}
								}
								else
								{
									current = current->Next;
								}
							}
							else
							{
								Commands->Enable_Stealth(o, false);
								current = NULL;
								tested = true;
							}
						}
					}
				}
			}
			x = x->Next();
		}
	}
	else
	{
		while (x)
		{
			GameObject *o = x->Data();
			if (o)
			{
				SmartGameObjDef *d = (SmartGameObjDef *)Get_Definition(o);
				if (!d->Is_Stealthed())
				{
					if (Is_Vehicle(o) || Is_Soldier(o))
					{
						Commands->Enable_Stealth(o, false);
					}
				}
			}
			x = x->Next();
		}
	}
}

SCRIPTS_API void Ranged_Gap_Effect(Gap_ListNode* FirstNode)
{
	SLNode<SmartGameObj> *x = GameObjManager::SmartGameObjList.Head();
	if (FirstNode)
	{
		while (x)
		{
			GameObject *o = x->Data();
			if (o)
			{
				bool stealth = false;
				bool blackout = false;
				Gap_ListNode *current = FirstNode;
				int test = Commands->Get_Player_Type(o);
				SmartGameObjDef *d = (SmartGameObjDef *)Get_Definition(o);
				if (!d->Is_Stealthed() && !Is_Script_Attached(o,"JFW_Submarine"))
				{
					if (Is_Vehicle(o) || Is_Soldier(o))
					{
						while (current)
						{
							if (current->active)
							{
								Vector3 GenPos = Commands->Get_Position(Commands->Find_Object(current->unitID));
								Vector3 TargetPos = Commands->Get_Position(o);
								float distance = Commands->Get_Distance(GenPos, TargetPos);
								if (distance <= current->range)
								{
									if (test == current->teamID)
									{
										stealth = true;
									}
									else
									{
										blackout = true;
									}
								}
							}
							current = current->Next;
						}
						Commands->Enable_Stealth(o, stealth);
						if (Commands->Is_A_Star(o))
						{
							if (blackout)
							{
								Commands->Send_Custom_Event(0,o,325523,1,0);
							}
							else
							{
								Commands->Send_Custom_Event(0,o,325523,0,0);
							}
						}
						current = NULL;
					}
				}
			}
			x = x->Next();
		}
	}
	else
	{
		while (x)
		{
			GameObject *o = x->Data();
			if (o)
			{
				SmartGameObjDef *d = (SmartGameObjDef *)Get_Definition(o);
				if (!d->Is_Stealthed())
				{
					if (Is_Vehicle(o) || Is_Soldier(o))
					{
						Commands->Enable_Stealth(o, false);
						if (Commands->Is_A_Star(o))
						{
							Commands->Send_Custom_Event(0,o,325523,0,0);
						}
					}
				}
			}
			x = x->Next();
		}
	}
}

SCRIPTS_API void SendShaderParam(const char* parameter, const char* value)
{
	Send_Shader_Param(parameter, value);
};

SCRIPTS_API void SendShaderParam(const char* parameter, int value) 
{
	char temp[256];
	sprintf(temp, "%d", value);
	Send_Shader_Param(parameter, temp);
};

SCRIPTS_API void SendShaderParam(const char* parameter, unsigned int value) 
{
	char temp[256];
	sprintf(temp, "%u", value);
	Send_Shader_Param(parameter, temp);
};

SCRIPTS_API void SendShaderParam(const char* parameter, float value) 
{
	char temp[256];
	sprintf(temp, "%f", value);
	Send_Shader_Param(parameter, temp);
};

SCRIPTS_API void SendShaderParam(const char* parameter, Vector2 value) 
{
	char temp[256];
	sprintf(temp, "%f|%f", value.X, value.Y);
	Send_Shader_Param(parameter, temp);
};

SCRIPTS_API void SendShaderParam(const char* parameter, Vector3 value) 
{
	char temp[256];
	sprintf(temp, "%f|%f|%f", value.X, value.Y, value.Z);
	Send_Shader_Param(parameter, temp);
};

SCRIPTS_API void SendShaderParam(const char* parameter, Vector4 value) 
{
	char temp[256];
	sprintf(temp, "%f|%f|%f|%f", value.X, value.Y, value.Z, value.W);
	Send_Shader_Param(parameter, temp);
};

SCRIPTS_API void SendShaderParamPlayer(GameObject* player, const char* parameter, const char* value)
{
	Send_Shader_Param_Player(player,parameter, value);
};

SCRIPTS_API void SendShaderParamPlayer(GameObject* player, const char* parameter, int value) 
{
	char temp[256];
	sprintf(temp, "%d", value);
	Send_Shader_Param_Player(player, parameter, temp);
};

SCRIPTS_API void SendShaderParamPlayer(GameObject* player, const char* parameter, unsigned int value) 
{
	char temp[256];
	sprintf(temp, "%u", value);
	Send_Shader_Param_Player(player, parameter, temp);
};

SCRIPTS_API void SendShaderParamPlayer(GameObject* player, const char* parameter, float value) 
{
	char temp[256];
	sprintf(temp, "%f", value);
	Send_Shader_Param_Player(player, parameter, temp);
};

SCRIPTS_API void SendShaderParamPlayer(GameObject* player, const char* parameter, Vector2 value) 
{
	char temp[256];
	sprintf(temp, "%f|%f", value.X, value.Y);
	Send_Shader_Param_Player(player, parameter, temp);
};

SCRIPTS_API void SendShaderParamPlayer(GameObject* player, const char* parameter, Vector3 value) 
{
	char temp[256];
	sprintf(temp, "%f|%f|%f", value.X, value.Y, value.Z);
	Send_Shader_Param_Player(player, parameter, temp);
};

SCRIPTS_API void SendShaderParamPlayer(GameObject* player, const char* parameter, Vector4 value) 
{
	char temp[256];
	sprintf(temp, "%f|%f|%f|%f", value.X, value.Y, value.Z, value.W);
	Send_Shader_Param_Player(player, parameter, temp);
};

SCRIPTS_API void SendShaderParamObj(const char* parameter, const char* value, GameObject* obj)
{
	Send_Shader_Param_Obj(parameter, value, obj);
};

SCRIPTS_API void SendShaderParamObj(const char* parameter, int value, GameObject* obj) 
{
	char temp[256];
	sprintf(temp, "%d", value);
	Send_Shader_Param_Obj(parameter, temp, obj);
};

SCRIPTS_API void SendShaderParamObj(const char* parameter, unsigned int value, GameObject* obj) 
{
	char temp[256];
	sprintf(temp, "%u", value);
	Send_Shader_Param_Obj(parameter, temp, obj);
};

SCRIPTS_API void SendShaderParamObj(const char* parameter, float value, GameObject* obj) 
{
	char temp[256];
	sprintf(temp, "%f", value);
	Send_Shader_Param_Obj(parameter, temp, obj);
};

SCRIPTS_API void SendShaderParamObj(const char* parameter, Vector2 value, GameObject* obj) 
{
	char temp[256];
	sprintf(temp, "%f|%f", value.X, value.Y);
	Send_Shader_Param_Obj(parameter, temp, obj);
};

SCRIPTS_API void SendShaderParamObj(const char* parameter, Vector3 value, GameObject* obj) 
{
	char temp[256];
	sprintf(temp, "%f|%f|%f", value.X, value.Y, value.Z);
	Send_Shader_Param_Obj(parameter, temp, obj);
};

SCRIPTS_API void SendShaderParamObj(const char* parameter, Vector4 value, GameObject* obj) 
{
	char temp[256];
	sprintf(temp, "%f|%f|%f|%f", value.X, value.Y, value.Z, value.W);
	Send_Shader_Param_Obj(parameter, temp, obj);
};

SCRIPTS_API void SendShaderParamObjPlayer(GameObject* player, const char* parameter, const char* value, GameObject* obj)
{
	Send_Shader_Param_Obj_Player(player,parameter, value, obj);
};

SCRIPTS_API void SendShaderParamObjPlayer(GameObject* player, const char* parameter, int value, GameObject* obj) 
{
	char temp[256];
	sprintf(temp, "%d", value);
	Send_Shader_Param_Obj_Player(player, parameter, temp, obj);
};

SCRIPTS_API void SendShaderParamObjPlayer(GameObject* player, const char* parameter, unsigned int value, GameObject* obj) 
{
	char temp[256];
	sprintf(temp, "%u", value);
	Send_Shader_Param_Obj_Player(player, parameter, temp, obj);
};

SCRIPTS_API void SendShaderParamObjPlayer(GameObject* player, const char* parameter, float value, GameObject* obj) 
{
	char temp[256];
	sprintf(temp, "%f", value);
	Send_Shader_Param_Obj_Player(player, parameter, temp, obj);
};

SCRIPTS_API void SendShaderParamObjPlayer(GameObject* player, const char* parameter, Vector2 value, GameObject* obj) 
{
	char temp[256];
	sprintf(temp, "%f|%f", value.X, value.Y);
	Send_Shader_Param_Obj_Player(player, parameter, temp, obj);
};

SCRIPTS_API void SendShaderParamObjPlayer(GameObject* player, const char* parameter, Vector3 value, GameObject* obj) 
{
	char temp[256];
	sprintf(temp, "%f|%f|%f", value.X, value.Y, value.Z);
	Send_Shader_Param_Obj_Player(player, parameter, temp, obj);
};

SCRIPTS_API void SendShaderParamObjPlayer(GameObject* player, const char* parameter, Vector4 value, GameObject* obj) 
{
	char temp[256];
	sprintf(temp, "%f|%f|%f|%f", value.X, value.Y, value.Z, value.W);
	Send_Shader_Param_Obj_Player(player, parameter, temp, obj);
};
RENEGADE_FUNCTION
void ScriptableGameObj::Start_Observers()
AT2(0x006B6C40,0x006B64E0);

SCRIPTS_API void Kill_All_Buildings_By_Team(int Team)
{
	BaseControllerClass::Find_Base(Team)->Set_Base_Destroyed(true);
	Set_Special_Base_Destruction();
}

bool Vehicle_Preset_Is_Air(int preset)
{
	DefinitionClass *def = Find_Definition(preset);
	if (!def)
	{
		return false;
	}
	if (def->Get_Class_ID() == 12304)
	{
		VehicleGameObjDef *def2 = (VehicleGameObjDef *)def;
		if (def2->Get_Type() == VEHICLE_TYPE_FLYING)
		{
			return true;
		}
	}
	return false;
}

bool SCRIPTS_API Create_Vehicle(const char *Preset_Name,float Delay,GameObject *Owner,int Team)
{
	if (Get_Vehicle(Owner))
	{
		return false;
	}
	int preset = Get_Definition_ID(Preset_Name);
	BaseControllerClass *base = BaseControllerClass::Find_Base(Team);
	DefinitionClass *vehicle = Find_Definition(preset);
	if (!vehicle)
	{
		return false;
	}
	BuildingGameObj *bg2 = ((BuildingGameObj *)base->Find_Building(BuildingConstants::TYPE_VEHICLE_FACTORY));
	VehicleFactoryGameObj *vf = 0;
	if (bg2)
	{
		vf = bg2->As_VehicleFactoryGameObj();
	}
	if (!vf && !Vehicle_Preset_Is_Air(preset))
	{
		return false;
	}
	if (vf && ((vf->Is_Destroyed()) || (vf->Is_Busy())))
	{
		if ((!Vehicle_Preset_Is_Air(preset)) || (!vf->Get_Definition().Get_Build_Ground_Only()))
		{
			return false;
		}
	}
	if (vf && (!Vehicle_Preset_Is_Air(preset) || !vf->Get_Definition().Get_Build_Ground_Only()))
	{
		float delay = 5.0;
		if (!base->Is_Base_Powered())
		{
			delay *= Get_Build_Time_Multiplier(Team);
		}
		vf->Request_Vehicle(preset,delay,Owner->As_SoldierGameObj());
	}
	else
	{
		BuildingGameObj *bg = ((BuildingGameObj *)base->Find_Building(BuildingConstants::TYPE_HELIPAD));
		AirFactoryGameObj *af = 0;
		if (bg)
		{
			af = bg->As_AirFactoryGameObj();
		}
		if (af && !af->Is_Destroyed() && !af->Is_Busy() && Vehicle_Preset_Is_Air(preset))
		{
			af->Create_Vehicle(preset,Owner->As_SoldierGameObj());
		}
		else
		{
			return false;
		}
	}
	return true;
}

SCRIPTS_API REF_DEF2(ConsoleFunctionList,DynamicVectorClass<ConsoleFunctionClass *>,0x0081DEB8,0x0081D098);

RENEGADE_FUNCTION
SCRIPTS_API void Sort_Function_List()
AT2(0x004282F0,0x00428470);

RENEGADE_FUNCTION
SCRIPTS_API void Verbose_Help_File()
AT2(0x004284F0,0x00428670);
