/*	Renegade Scripts.dll
	Scripts by zunnie - http://dev.mp-gaming.com
	Copyright 2011-2012 MP-Gaming

	This file is part of the Renegade scripts.dll
	The Renegade scripts.dll is free software; you can redistribute it and/or modify it 
	under the terms of the GNU General Public License as published by the Free
	Software Foundation; either version 2, or (at your option) any later
	version. See the file COPYING for more details.
	In addition, an exemption is given to allow Run Time Dynamic Linking of this code 
	with any closed source module that does not contain code covered by this licence.
	Only the source code to the module(s) containing the licenced code has to be released.
*/
#include "General.h"
#include "scripts.h"
#include "engine.h"
#include "tcw_vehicle.h"

void tcw_vehicle::Created(GameObject *obj)
{
	revealed = false;
	playdetected = true;
	playdamage = true;
	triggerstealthdetection = true;
	int random = Commands->Get_Random_Int(1,3);

	if (_stricmp(Commands->Get_Preset_Name(obj),"TCW_GDI_APC") == 0)
	{
		if (random == 1)
		{
			Create_2D_WAV_Sound_Team("purchase_gdi_apc_1.wav",1);
			Send_Message_Team(1,255,204,0,"APC ready for combat.");
		}
		else if (random == 2)
		{
			Create_2D_WAV_Sound_Team("purchase_gdi_apc_2.wav",1);
			Send_Message_Team(1,255,204,0,"APC what's the plan.");
		}
		else if (random == 3)
		{
			Create_2D_WAV_Sound_Team("purchase_gdi_apc_1.wav",1);
			Send_Message_Team(1,255,204,0,"APC ready for combat.");
		}
	}
	if (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_APC") == 0)
	{
		if (random == 1)
		{
			Create_2D_WAV_Sound_Team("purchase_gdi_apc_1.wav",0);
			Send_Message_Team(0,255,0,0,"APC ready for combat.");
		}
		else if (random == 2)
		{
			Create_2D_WAV_Sound_Team("purchase_gdi_apc_2.wav",0);
			Send_Message_Team(0,255,0,0,"APC what's the plan.");
		}
		else if (random == 3)
		{
			Create_2D_WAV_Sound_Team("purchase_gdi_apc_1.wav",0);
			Send_Message_Team(0,255,0,0,"APC ready for combat.");
		}
	}
	else if ( (_stricmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Harvester") == 0) || (_stricmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Harvester_Player") == 0) )
	{
		if (random == 1)
		{
			Create_2D_WAV_Sound_Team("purchase_gdi_harvester_1.wav",1);
			Send_Message_Team(1,255,204,0,"Let's get to that tib-zone.");
		}
		else if (random == 2)
		{
			Create_2D_WAV_Sound_Team("purchase_gdi_harvester_1.wav",1);
			Send_Message_Team(1,255,204,0,"Let's get to that tib-zone.");
		}
		else if (random == 3)
		{
			Create_2D_WAV_Sound_Team("purchase_gdi_harvester_2.wav",1);
			Send_Message_Team(1,255,204,0,"I'm ready to go, which way is the tiberium?");
		}
	}
	else if (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_GDI_Harvester_Player") == 0)
	{
		if (random == 1)
		{
			Create_2D_WAV_Sound_Team("purchase_gdi_harvester_1.wav",0);
			Send_Message_Team(0,255,0,0,"Let's get to that tib-zone.");
		}
		else if (random == 2)
		{
			Create_2D_WAV_Sound_Team("purchase_gdi_harvester_1.wav",0);
			Send_Message_Team(0,255,0,0,"Let's get to that tib-zone.");
		}
		else if (random == 3)
		{
			Create_2D_WAV_Sound_Team("purchase_gdi_harvester_2.wav",0);
			Send_Message_Team(0,255,0,0,"I'm ready to go, which way is the tiberium?");
		}
	}
	else if (_stricmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Juggernaut") == 0)
	{
		if (random == 1)
		{
			Create_2D_WAV_Sound_Team("purchase_gdi_juggernaut_1.wav",1);
			Send_Message_Team(1,255,204,0,"Looking for the big guns?");
		}
		else if (random == 2)
		{
			Create_2D_WAV_Sound_Team("purchase_gdi_juggernaut_2.wav",1);
			Send_Message_Team(1,255,204,0,"Juggernaut standing by.");
		}
		else if (random == 3)
		{
			Create_2D_WAV_Sound_Team("purchase_gdi_juggernaut_2.wav",1);
			Send_Message_Team(1,255,204,0,"Juggernaut standing by.");
		}
	}
	else if (_stricmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Mammoth_Tank") == 0)
	{
		if (random == 1)
		{
			Create_2D_WAV_Sound_Team("purchase_gdi_mammoth_1.wav",1);
			Send_Message_Team(1,255,204,0,"Mammoth Tank waiting orders.");
		}
		else if (random == 2)
		{
			Create_2D_WAV_Sound_Team("purchase_gdi_mammoth_2.wav",1);
			Send_Message_Team(1,255,204,0,"Mammoth Tank ready.");
		}
		else if (random == 3)
		{
			Create_2D_WAV_Sound_Team("purchase_gdi_mammoth_3.wav",1);
			Send_Message_Team(1,255,204,0,"Mammoth Tank assembled.");
		}
		Commands->Start_Timer(obj,this,1.0f,1008);//railgun tech check
	}
	else if (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Mammoth_Tank") == 0)
	{
		if (random == 1)
		{
			Create_2D_WAV_Sound_Team("purchase_gdi_mammoth_1.wav",0);
			Send_Message_Team(0,255,0,0,"Mammoth Tank waiting orders.");
		}
		else if (random == 2)
		{
			Create_2D_WAV_Sound_Team("purchase_gdi_mammoth_2.wav",0);
			Send_Message_Team(0,255,0,0,"Mammoth Tank ready.");
		}
		else if (random == 3)
		{
			Create_2D_WAV_Sound_Team("purchase_gdi_mammoth_3.wav",0);
			Send_Message_Team(0,255,0,0,"Mammoth Tank assembled.");
		}
	}
	else if (_stricmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Pitbull") == 0)
	{
		if (random == 1)
		{
			Create_2D_WAV_Sound_Team("purchase_gdi_pitbull_1.wav",1);
			Send_Message_Team(1,255,204,0,"Pitbull ready for action.");
		}
		else if (random == 2)
		{
			Create_2D_WAV_Sound_Team("purchase_gdi_pitbull_1.wav",1);
			Send_Message_Team(1,255,204,0,"Pitbull ready for action.");
		}
		else if (random == 3)
		{
			Create_2D_WAV_Sound_Team("purchase_gdi_pitbull_2.wav",1);
			Send_Message_Team(1,255,204,0,"Pitbull looking for some action.");
		}
	}
	else if (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Pitbull") == 0)
	{
		if (random == 1)
		{
			Create_2D_WAV_Sound_Team("purchase_gdi_pitbull_1.wav",0);
			Send_Message_Team(0,255,0,0,"Pitbull ready for action.");
		}
		else if (random == 2)
		{
			Create_2D_WAV_Sound_Team("purchase_gdi_pitbull_1.wav",0);
			Send_Message_Team(0,255,0,0,"Pitbull ready for action.");
		}
		else if (random == 3)
		{
			Create_2D_WAV_Sound_Team("purchase_gdi_pitbull_2.wav",0);
			Send_Message_Team(0,255,0,0,"Pitbull looking for some action.");
		}
	}
	else if (_stricmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Predator_Tank") == 0)
	{
		if (random == 1)
		{
			Create_2D_WAV_Sound_Team("purchase_gdi_predator_1.wav",1);
			Send_Message_Team(1,255,204,0,"Predator rolling out.");
		}
		else if (random == 2)
		{
			Create_2D_WAV_Sound_Team("purchase_gdi_predator_1.wav",1);
			Send_Message_Team(1,255,204,0,"Predator rolling out.");
		}
		else if (random == 3)
		{
			Create_2D_WAV_Sound_Team("purchase_gdi_predator_2.wav",1);
			Send_Message_Team(1,255,204,0,"Predator crew ready to roll.");
		}
	}
	else if (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Predator_Tank") == 0)
	{
		if (random == 1)
		{
			Create_2D_WAV_Sound_Team("purchase_gdi_predator_1.wav",0);
			Send_Message_Team(0,255,0,0,"Predator rolling out.");
		}
		else if (random == 2)
		{
			Create_2D_WAV_Sound_Team("purchase_gdi_predator_1.wav",0);
			Send_Message_Team(0,255,0,0,"Predator rolling out.");
		}
		else if (random == 3)
		{
			Create_2D_WAV_Sound_Team("purchase_gdi_predator_2.wav",0);
			Send_Message_Team(0,255,0,0,"Predator crew ready to roll.");
		}
	}
	else if (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Attack_Bike") == 0)
	{
		if (random == 1)
		{
			Create_2D_WAV_Sound_Team("purchase_nod_attackbike_1.wav",0);
			Send_Message_Team(0,255,0,0,"This bike's ready.");
		}
		else if (random == 2)
		{
			Create_2D_WAV_Sound_Team("purchase_nod_attackbike_2.wav",0);
			Send_Message_Team(0,255,0,0,"Let's go for a hunt.");
		}
		else if (random == 3)
		{
			Create_2D_WAV_Sound_Team("purchase_nod_attackbike_2.wav",0);
			Send_Message_Team(0,255,0,0,"Let's go for a hunt.");
		}
	}
	else if (_stricmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Attack_Bike") == 0)
	{
		if (random == 1)
		{
			Create_2D_WAV_Sound_Team("purchase_nod_attackbike_1.wav",1);
			Send_Message_Team(1,255,204,0,"This bike's ready.");
		}
		else if (random == 2)
		{
			Create_2D_WAV_Sound_Team("purchase_nod_attackbike_2.wav",1);
			Send_Message_Team(1,255,204,0,"Let's go for a hunt.");
		}
		else if (random == 3)
		{
			Create_2D_WAV_Sound_Team("purchase_nod_attackbike_2.wav",1);
			Send_Message_Team(1,255,204,0,"Let's go for a hunt.");
		}
	}
	else if (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Raider_Buggy") == 0)
	{
		if (random == 1)
		{
			Create_2D_WAV_Sound_Team("purchase_nod_raider_buggy_1.wav",0);
			Send_Message_Team(0,255,0,0,"Raider here.");
		}
		else if (random == 2)
		{
			Create_2D_WAV_Sound_Team("purchase_nod_raider_buggy_1.wav",0);
			Send_Message_Team(0,255,0,0,"Raider here.");
		}
		else if (random == 3)
		{
			Create_2D_WAV_Sound_Team("purchase_nod_raider_buggy_2.wav",0);
			Send_Message_Team(0,255,0,0,"Let's go on a raid.");
		}
	}
	else if (_stricmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Raider_Buggy") == 0)
	{
		if (random == 1)
		{
			Create_2D_WAV_Sound_Team("purchase_nod_raider_buggy_1.wav",1);
			Send_Message_Team(1,255,204,0,"Raider here.");
		}
		else if (random == 2)
		{
			Create_2D_WAV_Sound_Team("purchase_nod_raider_buggy_1.wav",1);
			Send_Message_Team(1,255,204,0,"Raider here.");
		}
		else if (random == 3)
		{
			Create_2D_WAV_Sound_Team("purchase_nod_raider_buggy_2.wav",1);
			Send_Message_Team(1,255,204,0,"Let's go on a raid.");
		}
	}
	else if (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Scorpion_Tank") == 0)
	{
		if (random == 1)
		{
			Create_2D_WAV_Sound_Team("purchase_nod_scorpion_1.wav",0);
			Send_Message_Team(0,255,0,0,"The scorpion's ready.");
		}
		else if (random == 2)
		{
			Create_2D_WAV_Sound_Team("purchase_nod_scorpion_2.wav",0);
			Send_Message_Team(0,255,0,0,"Scorpion ready for battle.");
		}
		else if (random == 3)
		{
			Create_2D_WAV_Sound_Team("purchase_nod_scorpion_2.wav",0);
			Send_Message_Team(0,255,0,0,"Scorpion ready for battle.");
		}
	}
	else if (_stricmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Scorpion_Tank") == 0)
	{
		if (random == 1)
		{
			Create_2D_WAV_Sound_Team("purchase_nod_scorpion_1.wav",1);
			Send_Message_Team(1,255,204,0,"The scorpion's ready.");
		}
		else if (random == 2)
		{
			Create_2D_WAV_Sound_Team("purchase_nod_scorpion_2.wav",1);
			Send_Message_Team(1,255,204,0,"Scorpion ready for battle.");
		}
		else if (random == 3)
		{
			Create_2D_WAV_Sound_Team("purchase_nod_scorpion_2.wav",1);
			Send_Message_Team(1,255,204,0,"Scorpion ready for battle.");
		}
	}
	else if (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Stealth_Tank") == 0)
	{
		if (random == 1)
		{
			Create_2D_WAV_Sound_Team("purchase_nod_stealth_tank_1.wav",0);
			Send_Message_Team(0,255,0,0,"Stealth tank clear for combat.");
		}
		else if (random == 2)
		{
			Create_2D_WAV_Sound_Team("purchase_nod_stealth_tank_1.wav",0);
			Send_Message_Team(0,255,0,0,"Stealth tank clear for combat.");
		}
		else if (random == 3)
		{
			Create_2D_WAV_Sound_Team("purchase_nod_stealth_tank_1.wav",0);
			Send_Message_Team(0,255,0,0,"Stealth tank clear for combat.");
		}
	}
	else if (_stricmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Stealth_Tank") == 0)
	{
		if (random == 1)
		{
			Create_2D_WAV_Sound_Team("purchase_nod_stealth_tank_1.wav",1);
			Send_Message_Team(1,255,204,0,"Stealth tank clear for combat.");
		}
		else if (random == 2)
		{
			Create_2D_WAV_Sound_Team("purchase_nod_stealth_tank_1.wav",1);
			Send_Message_Team(1,255,204,0,"Stealth tank clear for combat.");
		}
		else if (random == 3)
		{
			Create_2D_WAV_Sound_Team("purchase_nod_stealth_tank_1.wav",1);
			Send_Message_Team(1,255,204,0,"Stealth tank clear for combat.");
		}
	}
	else if (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Flame_Tank") == 0)
	{
		if (random == 1)
		{
			Create_2D_WAV_Sound_Team("purchase_nod_flame_tank_1.wav",0);
			Send_Message_Team(0,255,0,0,"The flames will rise.");
		}
		else if (random == 2)
		{
			Create_2D_WAV_Sound_Team("purchase_nod_flame_tank_1.wav",0);
			Send_Message_Team(0,255,0,0,"The flames will rise.");
		}
		else if (random == 3)
		{
			Create_2D_WAV_Sound_Team("purchase_nod_flame_tank_2.wav",0);
			Send_Message_Team(0,255,0,0,"Do not toy with the power of the flame.");
		}
	}
	else if (_stricmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Flame_Tank") == 0)
	{
		if (random == 1)
		{
			Create_2D_WAV_Sound_Team("purchase_nod_flame_tank_1.wav",1);
			Send_Message_Team(1,255,204,0,"The flames will rise.");
		}
		else if (random == 2)
		{
			Create_2D_WAV_Sound_Team("purchase_nod_flame_tank_1.wav",1);
			Send_Message_Team(1,255,204,0,"The flames will rise.");
		}
		else if (random == 3)
		{
			Create_2D_WAV_Sound_Team("purchase_nod_flame_tank_2.wav",1);
			Send_Message_Team(1,255,204,0,"Do not toy with the power of the flame.");
		}
	}
	else if ( (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Harvester") == 0) || 
			  (_stricmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Harvester_Player") == 0) )
	{
		if (random == 1)
		{
			Create_2D_WAV_Sound_Team("purchase_nod_harvester_1.wav",0);
			Send_Message_Team(0,255,0,0,"It is time for a harvest.");
		}
		else if (random == 2)
		{
			Create_2D_WAV_Sound_Team("purchase_nod_harvester_1.wav",0);
			Send_Message_Team(0,255,0,0,"It is time for a harvest.");
		}
		else if (random == 3)
		{
			Create_2D_WAV_Sound_Team("purchase_nod_harvester_2.wav",0);
			Send_Message_Team(0,255,0,0,"Tiberium is power.");
		}
	}
	else if (_stricmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Nod_Harvester_Player") == 0)
	{
		if (random == 1)
		{
			Create_2D_WAV_Sound_Team("purchase_nod_harvester_1.wav",1);
			Send_Message_Team(1,255,204,0,"It is time for a harvest.");
		}
		else if (random == 2)
		{
			Create_2D_WAV_Sound_Team("purchase_nod_harvester_1.wav",1);
			Send_Message_Team(1,255,204,0,"It is time for a harvest.");
		}
		else if (random == 3)
		{
			Create_2D_WAV_Sound_Team("purchase_nod_harvester_2.wav",1);
			Send_Message_Team(1,255,204,0,"Tiberium is power.");
		}
	}
}
void tcw_vehicle::Custom(GameObject *obj, int message, int param, GameObject *sender)
{
	if (message == CUSTOM_EVENT_VEHICLE_ENTERED)
	{
		if ( (strcmp(Commands->Get_Preset_Name(sender),"TCW_GDI_Commando") == 0) || (strcmp(Commands->Get_Preset_Name(sender),"TCW_GDI_Commando_Low") == 0) || 
			 (strcmp(Commands->Get_Preset_Name(sender),"TCW_Nod_Commando") == 0) || (strcmp(Commands->Get_Preset_Name(sender),"TCW_Nod_Commando_Low") == 0) )
		{
			Commands->Start_Timer(obj,this,0.5f,100100);
		}
		if ( (strcmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Pitbull") == 0) || (strcmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Pitbull") == 0) )
		{
			Commands->Start_Timer(obj,this,5.0f,1004);
			triggerstealthdetection = true;
		}
	}
	else if (message == CUSTOM_EVENT_VEHICLE_EXITED)
	{
		if ( (strcmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Pitbull") == 0) || (strcmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Pitbull") == 0) )
		{
			triggerstealthdetection = false;
		}
	}
	else if (message == 1004)//destealth unit
	{ 
		if (param == 1)
		{
			if (Commands->Get_Player_Type(obj) != Commands->Get_Player_Type(sender))
			{
				Vector3 mypos = Commands->Get_Position(obj);
				Vector3 target = Commands->Get_Position(sender);
				float distance = Commands->Get_Distance(mypos,target);

				if (distance < 76.0f)
				{
					if (!revealed)
					{
						Commands->Enable_Stealth(obj, false);
						Commands->Start_Timer(obj,this,2.0f,1005);//enable stealh again
						if (playdetected)
						{
							if (Commands->Get_Player_Type(obj) == 0)
							{
								Create_2D_WAV_Sound_Team("stealth_unit_detected_gdi.wav",1);
								Send_Message_Team(1,255,204,0,"Stealth unit detected.");
							}
							else if (Commands->Get_Player_Type(obj) == 1)
							{
								Create_2D_WAV_Sound_Team("stealth_unit_detected_nod.wav",0);
								Send_Message_Team(0,255,0,0,"Stealth unit detected.");
							}
							playdetected = false;
							Commands->Start_Timer(obj,this,10.0f,1006);//playdetected true
						}	
						revealed = true;
					}
				}
			}
		}
	}
}
void tcw_vehicle::Timer_Expired(GameObject *obj, int number)
{
	if (number == 100100)
	{
		Force_Occupant_Exit(obj,0);
	}
	else if (number == 1004)
	{
		Send_Custom_Event_To_Object(obj,"TCW_Nod_Shadow",1004,1,0);
		Send_Custom_Event_To_Object(obj,"TCW_Nod_Shadow_Low",1004,1,0);
		Send_Custom_Event_To_Object(obj,"TCW_Nod_Stealth_Tank",1004,1,0);
		Send_Custom_Event_To_Object(obj,"TCW_GDI_Stealth_Tank",1004,1,0);
		Send_Custom_Event_To_Object(obj,"TCW_Nod_Harvester",1004,1,0);
		Send_Custom_Event_To_Object(obj,"TCW_Nod_Harvester_Player",1004,1,0);
		Send_Custom_Event_To_Object(obj,"TCW_GDI_Nod_Harvester_Player",1004,1,0);
		Send_Custom_Event_To_Object(obj,"TCW_GDI_Sniper",1004,1,0);
		Send_Custom_Event_To_Object(obj,"TCW_GDI_Sniper_Low",1004,1,0);
		Send_Custom_Event_To_Object(obj,"TCW_Nod_Commando",1004,1,0);
		Send_Custom_Event_To_Object(obj,"TCW_Nod_Commando_Low",1004,1,0);
		if (triggerstealthdetection)
		{
			if ( (Commands->Get_Player_Type(obj) == 0) || (Commands->Get_Player_Type(obj) == 1) )
			{
				Commands->Start_Timer(obj,this,5.0f,1004);
			}
		}
	}
	else if (number == 1005)//enable stealth again after distance check 
	{
		Commands->Enable_Stealth(obj, true);
		revealed = false;
	}
	else if (number == 1006)
	{
		playdetected = true;
	}
	else if (number == 1007)
	{
		playdamage = true;
	}
	else if (number == 151515)//unused now, old code...
	{
		if (Find_Object_By_Preset(2,"TCW_Tech_Railgun_Available"))
		{
			if (strcmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Mammoth_Tank") == 0)
			{
				Commands->Give_PowerUp(obj,"TCW_Mammoth_Railgun_Upgrade",false);
				Commands->Select_Weapon(obj,"TCW_Weapon_Mammoth_Railgun");
			}
		}
		else
		{
			Commands->Start_Timer(obj,this,5.0f,1008);
		}
	}
}
void tcw_vehicle::Killed(GameObject *obj, GameObject *shooter)
{
	if (Commands->Get_Player_Type(obj) == 0)
	{
		if ( (strcmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Harvester") == 0) || 
			 (strcmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Harvester_Player") == 0) || 
			 (strcmp(Commands->Get_Preset_Name(obj),"TCW_Nod_GDI_Harvester_Player") == 0) )
		{
			Create_2D_WAV_Sound_Team("nod_harvester_lost.wav",0);
			Send_Message_Team(0,255,0,0,"Harvester lost.");
		}
		else
		{
			Create_2D_WAV_Sound_Team("nod_unit_lost.wav",0);
			Send_Message_Team(0,255,0,0,"Unit lost.");
		}
	}
	else if (Commands->Get_Player_Type(obj) == 1)
	{
		if ( (strcmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Harvester") == 0) || 
			 (strcmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Harvester_Player") == 0) || 
			 (strcmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Nod_Harvester_Player") == 0) )
		{
			Create_2D_WAV_Sound_Team("gdi_harvester_lost.wav",1);
			Send_Message_Team(1,255,204,0,"Harvester lost.");
		}
		else
		{
			Create_2D_WAV_Sound_Team("gdi_unit_lost.wav",1);
			Send_Message_Team(1,255,204,0,"Unit lost.");
		}
	}
}
void tcw_vehicle::Damaged(GameObject *obj, GameObject *damager, float damage)
{
	if ( (strcmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Harvester") == 0) || 
		 (strcmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Harvester_Player") == 0) || 
		 (strcmp(Commands->Get_Preset_Name(obj),"TCW_GDI_Nod_Harvester_Player") == 0) )
	{
		if (playdamage)
		{
			if (damage > 0.0)
			{
				playdamage = false;
				Create_2D_WAV_Sound_Team("gdi_harvester_under_attack.wav",1);
				Send_Message_Team(1,255,204,0,"Harvester under attack.");
				Commands->Start_Timer(obj,this,20.0f,1007);//playdamage true
			}
		}
	}
	else if ( (strcmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Harvester") == 0) || 
			  (strcmp(Commands->Get_Preset_Name(obj),"TCW_Nod_Harvester_Player") == 0)  || 
			  (strcmp(Commands->Get_Preset_Name(obj),"TCW_Nod_GDI_Harvester_Player") == 0) )
	{
		if (playdamage)
		{
			if (damage > 0.0)
			{
				playdamage = false;
				Create_2D_WAV_Sound_Team("nod_harvester_under_attack.wav",0);
				Send_Message_Team(0,255,0,0,"Harvester under attack.");
				Commands->Start_Timer(obj,this,20.0f,1007);//playdamage true
			}
		}
	}
}
void tcw_vehicle::Register_Auto_Save_Variables()
{
	Auto_Save_Variable(&triggerstealthdetection,sizeof(triggerstealthdetection),1);
	Auto_Save_Variable(&playdetected,sizeof(playdetected),2);
	Auto_Save_Variable(&revealed,sizeof(revealed),3);
	Auto_Save_Variable(&playdamage,sizeof(playdamage),4);
}

void tcw_vehexit_killtimer::Created(GameObject *obj)
{
	timerid = Commands->Get_ID(obj);
}
void tcw_vehexit_killtimer::Custom(GameObject *obj, int message, int param, GameObject *sender)
{
	if (message == CUSTOM_EVENT_VEHICLE_EXITED)
	{
		Commands->Start_Timer(obj,this,60.0f,Commands->Get_ID(obj));
	}
}
void tcw_vehexit_killtimer::Timer_Expired(GameObject *obj, int number)
{
	if (number == timerid)
	{
		if (!Get_Vehicle_Driver(obj))
		{
			Commands->Destroy_Object(obj);
		}
	}
}
void tcw_vehexit_killtimer::Register_Auto_Save_Variables()
{
	Auto_Save_Variable(&timerid,sizeof(timerid),1);
}


ScriptRegistrant<tcw_vehexit_killtimer> tcw_vehexit_killtimer_Registrant("tcw_vehexit_killtimer","");
ScriptRegistrant<tcw_vehicle> tcw_vehicle_Registrant("tcw_vehicle","");